package u8c.impl;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pr.pray.PraybillHeaderVO;
import nc.vo.pr.pray.PraybillItemVO;
import nc.vo.pr.pray.PraybillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.itf.po.IDemandPurchaseRequisition;
import u8c.ui.mytest.panel.DemandTestUI;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;

public class DemandPurchaseRequisitionImpl implements IDemandPurchaseRequisition {
	
	private IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	DemandTestUI frameUI = null;
	
	/**
	 * ݲϲɹ빺
	 * @param s
	 * @throws Exception 
	 */
	@Override
	//HRAggVO s
	public void addPraybillVO(DemandVO demandVO, List<DemandBVO> demandBVOs) throws Exception {
		
//		DemandVO DemandBVO
		
//		DemandVO demandVO = (DemandVO) s.getParentVO();//
//		CircularlyAccessibleValueObject[] demandBVOList =  s.getAllChildrenVO();//
//		List<DemandBVO> demandBVOs = new ArrayList();
//		for(CircularlyAccessibleValueObject vo : demandBVOList) {
//			if(vo instanceof DemandBVO) {
//				demandBVOs.add((DemandBVO)vo);
//			}
//		}
//		if(demandBVOs.size()==0) {
//			throw new BusinessException("ǰϲɹûݣ");
//		}
		PraybillHeaderVO header = new PraybillHeaderVO();
		header.setPk_corp(demandVO.getPk_corp());//˾
		header.setDpraydate(demandVO.getDbilldate());//-->빺
		header.setIpraysource(5);//빺Դ
		header.setIpraytype(2);//빺
		header.isDirecttransit(new UFBoolean(true));// -->Ƿֱˣ
		header.setIbillstatus(0);//״̬
		header.setCpraypsn(demandVO.getWorkmanid());//빺id-->ҵԱ
		header.setCdeptid(demandVO.getPlandeptid());//빺id-->ƻ
		header.setVmemo(demandVO.getVnote());//ע-ע
		header.setDr(0);
		header.setCaccountyear(String.valueOf(new UFDate().getYear()));//
		header.setCoperator(demandVO.getBillmaker());//Ƶ-Ƶ
		PraybillItemVO[] items = new PraybillItemVO[demandBVOs.size()];
		for (int i = 0; i < demandBVOs.size(); i++) {
			DemandBVO demandBVO = demandBVOs.get(i);
			PraybillItemVO praybillItemVO = new PraybillItemVO();
			praybillItemVO.setPk_corp(demandVO.getPk_corp()); // ˾
			// 帳ֵ
			praybillItemVO.setRowno((i+1)*10+"");//кţģcrownoǶֻRowno
			praybillItemVO.setCmangid(getCmangid(demandBVO.getCmaterialcode())); //-
			praybillItemVO.setNpraynum(demandBVO.getNum()); //-
			praybillItemVO.setDdemanddate(new UFDate());//--> 
			String cprojectid = "";//Ŀid
			if(demandBVO.getPrjcode().startsWith("1001")) {
				cprojectid = demandBVO.getPrjcode();
			}
			else {
				cprojectid = GetBaseDAOUtil.getprojectid(demandBVO.getPrjcode());
			}
			praybillItemVO.setCprojectid(cprojectid);
//			praybillItemVO.setCassistunit(demandBVO.getCastunitid());//λ
//			praybillItemVO.setNassistnum(new UFDouble(demandBVO.getNastnum()));//
//			praybillItemVO.setVproducenum(demandBVO.getVbatchcode());//κ
			items[i] = praybillItemVO;
		}
		PraybillVO vo = new PraybillVO();
		vo.setParentVO(header);
		vo.setChildrenVO(items);
		PraybillVO[] praybillVOs = new PraybillVO[1];
		praybillVOs[0] = vo;
		IplatFormEntry iIplatFormEntry = (IplatFormEntry)NCLocator.getInstance().lookup(IplatFormEntry.class.getName());
		ArrayList retObj = (ArrayList) iIplatFormEntry.processAction("SAVEBASE", "20", vo.getHeadVO().getDpraydate().toString(), null, vo, null, null);
		MessageDialog.showHintDlg(frameUI, "ɹ", "빺ɹ");
//		IPrayBillMaintainAPI prayBillMaintainAPI = NCLocator.getInstance().lookup(IPrayBillMaintainAPI.class);
//		prayBillMaintainAPI.insert(praybillVOs);

	}

	/**
	 * codeѯ
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangid(String code) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invbasdoc from bd_invbasdoc" + " where invcode  ='" + code + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8Ccode:" + code);
		}
		return cmangid;
	}

}
